#include "parser.h"
#include <QMessageBox>
#include <QTableView>
#include <QString>
#include <QDebug>

parser::parser(QTreeWidget* tree, const QString& title):
    treeWidget(tree),
    treeWidgetItem(nullptr),
    tmp(title)
{}

bool parser::startElement(const QString&,const QString&,const QString& tagName,const QXmlAttributes&) {
    if (tagName == "catalog")
    {
       treeWidgetItem = new QTreeWidgetItem(treeWidget);
       treeWidgetItem->setText(0, tmp);
    }
    else if (tagName == "LINK")
    {
        treeWidgetItem = new QTreeWidgetItem(treeWidgetItem);
        treeWidgetItem->setText(0, tagName);
    }
    else
        treeWidgetItem = new QTreeWidgetItem(treeWidgetItem);
    treeWidgetItem->setFont(0, QFont("Times", 8));
    return true;
}

bool parser::characters(const QString& strText)
{
    text = strText;
    return true;
}

bool parser::endElement(const QString&, const QString&, const QString& str)
{
    if (str != "array" && str != "catalog" && str != "LINK")
    {
        if (str == "Address" || str == "FullName")
            treeWidgetItem->parent()->setText(0, text);
        if (str == "Address" || str == "global_id" || str == "ID")
            treeWidgetItem->setHidden(true);
        if(str == "CadastralFieldCoast")
        {
            treeWidgetItem->setText(0, "Площадь земельного участка:\t" + text);
        }
        else if(str == "SubjectOfTrades")
        {
            treeWidgetItem->setText(0, "Предмет торгов:\t\t" + text);
        }
        else if(str == "LicensePrimeCost")
        {
            treeWidgetItem->setText(0, "Стоимость:\t\t\t" + text);
        }
        else if(str == "Sold")
        {
            treeWidgetItem->setText(0, "Продано:\t\t\t" + text);
        }
        else if(str == "NumberRoom")
        {
            treeWidgetItem->setText(0, "Номер помещения:\t\t\t" + text);
        }
        else if(str == "DepartmentalAffiliation")
        {
            treeWidgetItem->setText(0, "Номер расположения Префекта:\t\t" + text);
        }
        else if(str == "District")
        {
            treeWidgetItem->setText(0, "Район:\t\t\t\t" + text);
        }
        else
        {
             treeWidgetItem->setHidden(true);
        }
        treeWidgetItem = treeWidgetItem->parent();
    }
    else if (str == "LINK")
        treeWidgetItem = treeWidgetItem->parent();
    else if (str == "array")
        treeWidgetItem = treeWidgetItem->parent();

    return true;
}

bool parser::Errors(const QXmlParseException& exception)
{
    qDebug() << "Line:" << exception.lineNumber()
             << ", Column:" << exception.columnNumber()
             << ", Message:" << exception.message();
    return false;
}
